diff --git a/libr/util/buf.c b/libr/util/buf.c
index e22bcbe2ce9..5a4deebf53b 100644
--- a/libr/util/buf.c
+++ b/libr/util/buf.c
@@ -161,6 +161,7 @@ R_API RBuffer *r_buf_new() {
 	RBuffer *b = R_NEW0 (RBuffer);
 	if (b) {
 		b->fd = -1;
+		b->Oxff = 0xff;
 	}
 	return b;
 }
@@ -498,11 +499,14 @@ static int r_buf_fcpy_at (RBuffer *b, ut64 addr, ut8 *buf, const char *fmt, int
 		eprintf ("r_buf_fcpy_at not supported yet for r_buf_new_file\n");
 		return 0;
 	}
-	if (addr == R_BUF_CUR)
+	if (addr == R_BUF_CUR) {
 		addr = b->cur;
-	else addr -= b->base;
-	if (addr == UT64_MAX || addr > b->length)
+	} else {
+		addr -= b->base;
+	}
+	if (addr == UT64_MAX || addr > b->length) {
 		return -1;
+	}
 	tsize = 2;
 	for (i = len = 0; i < n; i++)
 	for (j = 0; fmt[j]; j++) {
diff --git a/libr/util/p_format.c b/libr/util/p_format.c
index ac0c6baf39f..5c9c53fdebb 100644
--- a/libr/util/p_format.c
+++ b/libr/util/p_format.c
@@ -1325,7 +1325,9 @@ int r_print_format_struct_size(const char *f, RPrint *p, int mode) {
 				free (structname);
 				break;
 			}
-			if (endname) *endname = '\0';
+			if (endname) {
+				*endname = '\0';
+			}
 			format = strchr (structname, ' ');
 			if (format) {
 				tmp = *format;
@@ -1336,7 +1338,14 @@ int r_print_format_struct_size(const char *f, RPrint *p, int mode) {
 			} else {
 				format = sdb_get (p->formats, structname + 1, NULL);
 			}
-			size += tabsize * r_print_format_struct_size (format, p, mode);
+			int newsize = r_print_format_struct_size (format, p, mode);
+			if (newsize < 1) {
+				eprintf ("Cannot find size for %s\n", format);
+				return 0;
+			}
+			if (format && newsize > 0) {
+				size += tabsize * newsize;
+			}
 			free (structname);
 			}
 			break;
